"use strict";

const zlib = require("zlib");

const decodeString = require("@promistream/decode-string");
const fromNodeStream = require("@promistream/from-node-stream");
const parseSitemap = require("@promistream/parse-sitemap");
const pipe = require("@promistream/pipe");

module.exports = function parseSitemapResponse(response) {
	return pipe([
		fromNodeStream(response),
		(response.request.url.endsWith(".gz"))
			? fromNodeStream(zlib.createGunzip())
			: null,
		decodeString("utf8"),
		parseSitemap(),
	]);
};
