"use strict";

const htmlEntities = require("html-entities");
const createDatasheet = require("../../shared/create-datasheet");

module.exports = function normalizeProduct() {
	return async function (api) {
		let { data } = api;

		createDatasheet(api, {
			priority: 0.8,
			source: "st",
			manufacturer: "STMicroelectronics",
			productID: data.productId,
			name: data.cellData["XJE010_VT-007"],
			description: htmlEntities.decode(data.cellData["XJE014_VT-007"]),
			url: data.datasheetLink
		});
	};
};
